# Record Class CLNImageInfo

java.lang.Object
java.lang.Record
com.io7m.calino.api.CLNImageInfo

Record Components:
  `sizeX` - The size, in pixels, of the image data on the X axis
  `sizeY` - The size, in pixels, of the image data on the Y axis
  `sizeZ` - The size, in pixels, of the image data on the Z axis
  `channelsLayout` - The layout of the channels in the image data
  `channelsType` - The type of the channels in the image data
  `compressionMethod` - The compression method used for the image data
  `superCompressionMethod` - The supercompression method used to encapsulate image data
  `coordinateSystem` - The coordinate system orientation
  `colorSpace` - The image color space
  `flags` - The image flags
  `dataByteOrder` - The byte order of image data

public record CLNImageInfo(int sizeX, int sizeY, int sizeZ, CLNChannelsLayoutDescriptionType channelsLayout, CLNChannelsTypeDescriptionType channelsType, CLNCompressionMethodType compressionMethod, CLNSuperCompressionMethodType superCompressionMethod, CLNCoordinateSystem coordinateSystem, CLNColorSpaceType colorSpace, Set<CLNImageFlagType> flags, CLNByteOrder dataByteOrder) extends Record

Information about an image.

This describes the size and format of image data included in a texture file.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CLNImageInfo(int sizeX, int sizeY, int sizeZ, CLNChannelsLayoutDescriptionType channelsLayout, CLNChannelsTypeDescriptionType channelsType, CLNCompressionMethodType compressionMethod, CLNSuperCompressionMethodType superCompressionMethod, CLNCoordinateSystem coordinateSystem, CLNColorSpaceType colorSpace, Set<CLNImageFlagType> flags, CLNByteOrder dataByteOrder)`
  Information about an image.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `CLNChannelsLayoutDescriptionType`
  `channelsLayout()`
  Returns the value of the `channelsLayout` record component.
  `CLNChannelsTypeDescriptionType`
  `channelsType()`
  Returns the value of the `channelsType` record component.
  `CLNColorSpaceType`
  `colorSpace()`
  Returns the value of the `colorSpace` record component.
  `CLNCompressionMethodType`
  `compressionMethod()`
  Returns the value of the `compressionMethod` record component.
  `CLNCoordinateSystem`
  `coordinateSystem()`
  Returns the value of the `coordinateSystem` record component.
  `CLNByteOrder`
  `dataByteOrder()`
  Returns the value of the `dataByteOrder` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `Set<CLNImageFlagType>`
  `flags()`
  Returns the value of the `flags` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `String`
  `showSize()`
  `int`
  `sizeX()`
  Returns the value of the `sizeX` record component.
  `int`
  `sizeXForMipLevel(int level)`
  The size of the image on the X axis at the given mip level.
  `int`
  `sizeY()`
  Returns the value of the `sizeY` record component.
  `int`
  `sizeYForMipLevel(int level)`
  The size of the image on the Y axis at the given mip level.
  `int`
  `sizeZ()`
  Returns the value of the `sizeZ` record component.
  `int`
  `sizeZForMipLevel(int level)`
  The size of the image on the Z axis at the given mip level.
  `CLNSuperCompressionMethodType`
  `superCompressionMethod()`
  Returns the value of the `superCompressionMethod` record component.
  `int`
  `texelBlockAlignment()`
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CLNImageInfo

    public CLNImageInfo(int sizeX, int sizeY, int sizeZ, CLNChannelsLayoutDescriptionType channelsLayout, CLNChannelsTypeDescriptionType channelsType, CLNCompressionMethodType compressionMethod, CLNSuperCompressionMethodType superCompressionMethod, CLNCoordinateSystem coordinateSystem, CLNColorSpaceType colorSpace, Set<CLNImageFlagType> flags, CLNByteOrder dataByteOrder)

    Information about an image.

    This describes the size and format of image data included in a texture file.

    Parameters:
      `sizeX` - The size, in pixels, of the image data on the X axis
      `sizeY` - The size, in pixels, of the image data on the Y axis
      `sizeZ` - The size, in pixels, of the image data on the Z axis
      `channelsLayout` - The layout of the channels in the image data
      `channelsType` - The type of the channels in the image data
      `compressionMethod` - The compression method used for the image data
      `superCompressionMethod` - The supercompression method used to encapsulate image data
      `coordinateSystem` - The coordinate system orientation
      `colorSpace` - The image color space
      `flags` - The image flags
      `dataByteOrder` - The byte order of image data

- ## Method Details

  - ### texelBlockAlignment

    public int texelBlockAlignment()
    Returns:
      The required alignment of texel data

  - ### showSize

    public String showSize()
    Returns:
      A humanly-readable description of the image size

  - ### sizeXForMipLevel

    public int sizeXForMipLevel(int level)
    The size of the image on the X axis at the given mip level.
    Parameters:
      `level` - The mip level
    Returns:
      The size

  - ### sizeYForMipLevel

    public int sizeYForMipLevel(int level)
    The size of the image on the Y axis at the given mip level.
    Parameters:
      `level` - The mip level
    Returns:
      The size

  - ### sizeZForMipLevel

    public int sizeZForMipLevel(int level)
    The size of the image on the Z axis at the given mip level.
    Parameters:
      `level` - The mip level
    Returns:
      The size

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with the `compare` method from their corresponding wrapper classes.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### sizeX

    public int sizeX()
    Returns the value of the `sizeX` record component.
    Returns:
      the value of the `sizeX` record component

  - ### sizeY

    public int sizeY()
    Returns the value of the `sizeY` record component.
    Returns:
      the value of the `sizeY` record component

  - ### sizeZ

    public int sizeZ()
    Returns the value of the `sizeZ` record component.
    Returns:
      the value of the `sizeZ` record component

  - ### channelsLayout

    public CLNChannelsLayoutDescriptionType channelsLayout()
    Returns the value of the `channelsLayout` record component.
    Returns:
      the value of the `channelsLayout` record component

  - ### channelsType

    public CLNChannelsTypeDescriptionType channelsType()
    Returns the value of the `channelsType` record component.
    Returns:
      the value of the `channelsType` record component

  - ### compressionMethod

    public CLNCompressionMethodType compressionMethod()
    Returns the value of the `compressionMethod` record component.
    Returns:
      the value of the `compressionMethod` record component

  - ### superCompressionMethod

    public CLNSuperCompressionMethodType superCompressionMethod()
    Returns the value of the `superCompressionMethod` record component.
    Returns:
      the value of the `superCompressionMethod` record component

  - ### coordinateSystem

    public CLNCoordinateSystem coordinateSystem()
    Returns the value of the `coordinateSystem` record component.
    Returns:
      the value of the `coordinateSystem` record component

  - ### colorSpace

    public CLNColorSpaceType colorSpace()
    Returns the value of the `colorSpace` record component.
    Returns:
      the value of the `colorSpace` record component

  - ### flags

    public Set<CLNImageFlagType> flags()
    Returns the value of the `flags` record component.
    Returns:
      the value of the `flags` record component

  - ### dataByteOrder

    public CLNByteOrder dataByteOrder()
    Returns the value of the `dataByteOrder` record component.
    Returns:
      the value of the `dataByteOrder` record component